// ZenLib::ZtringList - vector<std::string> is better
// Copyright (C) 2002-2003 Jrme Martinez, Zen@MediaArea.net
//
// This software is provided 'as-is', without any express or implied
// warranty.  In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//    claim that you wrote the original software. If you use this software
//    in a product, an acknowledgment in the product documentation would be
//    appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//    misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ZtringList
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
// Version 0.1.0
// -------------
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//---------------------------------------------------------------------------
#ifndef ZenLib_ZtringListH
#define ZenLib_ZtringListH
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include <ZenLib/Ztring.h>
#include <vector>
//---------------------------------------------------------------------------

//***************************************************************************
// Classe ZtringList
//***************************************************************************
namespace ZenLib
{

class ZtringList : public std::vector<Ztring>
{
public :
    //Gestion de la classe
    void ZtringList_Common (int n=0, const Ztring &Separateur=_T(";"), const Ztring &Source=_T(""));
    ZtringList (int n=0, const Ztring &Separateur=_T(";"), const Ztring &Source=_T(""));
    ZtringList (const ZtringList &Source);
    ZtringList (const Ztring &Source);
    ZtringList (const Char *Source);
    ~ZtringList ();

    //Operateurs
    ZtringList operator + (const ZtringList &Source) const;
    ZtringList &operator += (const Ztring &Source);
    ZtringList &operator = (const ZtringList &Source);
    bool operator == (const ZtringList &Source) const;
    bool operator != (const ZtringList &Source) const;
    Ztring &operator () (size_t Pos); ///< Same as [], but write a empty string if Pos doesn't exist yet

    //Edition
    Ztring Lire () const; //Lecture de tout
    Ztring Lire (size_t Pos) const; //Lecture d'un champs
    int Ecrire (const Ztring &AEcrire); //Ecriture de tout
    int Ecrire (const Ztring &AEcrire, size_t Pos); //Ecriture d'un champs
/*
    int EcrireEx (const CChaine &AEcrire, int Pos); //Ecriture d'un champs avec options (Espace = Ne pas ecrire)
    int Ajouter (const CChaine &AAjouter); //Ajout d'un champs a la fin
    int Inserer (const CChaine &AInserer, int Pos); // Insertion d'un champs et decalage des champs suivants
    int Permuter (int Pos_A, int Pos_B); // Permutation de deux champs
    int Supprimer (); //Suppression de tout
    int Supprimer (int Pos); //Suppression d'un champs et decalage des champs suivants
    int Trier (int Options=0); //tri
*/
    intu Rechercher (const Ztring &ARechercher, intu PosDebut=0, const Ztring &Comparaison=_T("=="), int Options=0) const; //recherche un champs contenant Proprietes
/*

    //Informations
    int Taille_Get () const; //Nombre de champs
    int Taille_Max_Get (); //Nombre d'endroits reserves pour les champs
    int Taille_Max_Set (int Taille_Max_Nouveau); //Modification de la taille maximum d'un tableau (a titre indicatif)
    CChaine Separateur_Get () const;
*/
    int Separateur_Set (const Ztring &Separateur_Nouveau);
    /// @brief Return the length of the longest string in the list.
    int MaxStringLength ();


protected :
    //CChaine** Chaine;
    Ztring Separateur;
    //int Taille;
    //int Taille_Max;
    //int Nettoyer(); //Rendu necessaire par operateur () et []

};

} //namespace
#endif

